pipeline {
    agent any
    parameters {
        text(name: 'ECR_PASS', defaultValue: '', description: 'The ECR Password to use')
        text(name: 'ANSIBLE_SERVER', defaultValue: '170.64.174.82', description: 'The IP address of the ansible server that will execute the ansible jobs.')
    }
    stages {
        stage("copy ansible to ansible server") {
            environment {
                AWS_ACCESS_KEY_ID=credentials('AWS_ACCESS_KEY_ID_ST')
                AWS_SECRET_ACCESS_KEY=credentials('AWS_SECRET_ACCESS_KEY_ST')
            }
            steps {
                script {
                    echo "copying all necessary fiels to ansible control node."
                    
                    sshagent(['root-default-ssh-key']) { // SSH to the Ansible Server
                        sh "envsubst < ansible/prepare-ansible-server.sh > ansible/prepare-ansible-server-populated.sh"
                        sh "scp -o StrictHostKeyChecking=no ansible/* root@${params.ANSIBLE_SERVER}:/root" 

                        // Copy the private keys to SSH to the AWS endpoints
                        withCredentials([sshUserPrivateKey(credentialsId: 'ansible-ssh-key', keyFileVariable: 'keyfile', usernameVariable: 'user')]) {
                            sh 'scp ${keyfile} root@' + "${params.ANSIBLE_SERVER}" + ':/root/ansible'
                        }
                    }
                }
            }
        }

        stage("execute ansible playbook") { 
            steps {  
                script {
                    echo "calling ansbile playbook to configure ec2 instances"
                
                    def remote = [:]
                    remote.name = "ansible-server"
                    remote.host = "${params.ANSIBLE_SERVER}"
                    remote.allowAnyHosts = true // Equivalent to StrictHostKeyChecking=no    

                    withCredentials([sshUserPrivateKey(credentialsId: 'root-default-ssh-key', keyFileVariable: 'keyfile', usernameVariable: 'user')]) {
                        remote.user = user
                        remote.identityFile = keyfile

                        sshScript remote: remote, script: 'ansible/prepare-ansible-server-populated.sh' // the script must be relative from the account executing
                        sshCommand remote: remote, command: "ansible-playbook deploy-docker-generic.yaml -e \"ecr_username=AWS ecr_password=${params.ECR_PASS} DB_ROOT_PASSWORD=Welcome123! DB_USER_USERNAME=admin DB_USER_PASSWORD=Welcome123! DB_NAME=mydb DB_ENDPOINT=mysql\""
                        sshCommand remote: remote, command: 'rm prepare-ansible-server-populated.sh'
                    }
                } 
            }
        }
    }
}